
/*
 * Example of the use of open_scan() function.
 */

#include <iostream.h>

int main(int argc, char **argv)
{
    cout << "scan2.S: Demonstrating open_scan().\n";

    init_coral(argv[0]);
  
    \[
      clear(interactive_mode).
    \]

    /* First consult the data file which contains facts of the
     * form data(1,2), data(2,3), etc.
     */
    \[
      consult("data.F").
    \]

    Cor_ScanDesc *scan = open_scan("data(X,X).");

    Cor_Tuple *tuple;

      /* Iterate over the tuples in the relation */
    for (tuple = scan->next_tuple(); !(scan->no_match());
                     tuple = scan->next_tuple()) {

          // Print them out as tuples 
        cout << "data(" << *tuple << ").\n";
    }

    exit_coral();

    return(0);
}

