// *************************************************************************
//    IndexStruct.h
// *************************************************************************

#ifndef _IndexStruct_H_
#define _IndexStruct_H_

#include "BitVector.h"
#include "Debug.h"

// *************************************************************************

enum PersIndexKind {
    COR_BPLUSTREE,
    COR_HASHTABLE
};

// *************************************************************************
// Dummy generic class declaration. In case hash indexes are added later.

class Cor_IndexStruct  {
public:
    // Number of attributes on which the index is created
    int arity;

    //    virtual void operator=(PersistentIndex& index2) = 0 ;

    virtual PersIndexKind kindof() = 0 ;
    virtual int valid() = 0 ;
    virtual void create(Cor_BitVector *, int, int) = 0 ;
    virtual void insert(USERDESC *, Cor_Schema&) = 0;
    virtual int matches(char *, int) = 0;
    virtual void destroy() = 0 ;
    virtual void Cor_print_adornment(ostream *outf) = 0;
};

// *************************************************************************

#endif _IndexStruct_H_
