// *************************************************************************
//    RelationList.C
// *************************************************************************

#include "RelationList.h"
#include "Debug.h"

// *************************************************************************
void Cor_RelationList::append_relation(Cor_StorageRelation *_rel)
{ 
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    Cor_RelationLink *n_link = new Cor_RelationLink(_rel);

    if (!reln_lastptr) {
        reln_chain = reln_lastptr = n_link;
    } else {
        reln_lastptr->next = n_link;
        reln_lastptr = n_link;
    }
}

// *************************************************************************
void Cor_RelationList::append(Cor_RelationLink *n_link)
{ 
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    if (!reln_lastptr) {
        reln_chain = reln_lastptr = n_link;
    } else {
        reln_lastptr->next = n_link;
        reln_lastptr = n_link;
    }
}

// *************************************************************************

