// *************************************************************************
//	SupMagic.h
// *************************************************************************

#ifndef _SupMagic_H_
#define _SupMagic_H_

#include "Collection.h"
#include "Rule.h"
#include "Literal.h"

// *************************************************************************

void supmagic(Cor_Collection *ad_rules,
        Cor_Collection *magic_rules);
void do_supp_magic_on_rule(Cor_Clause *adrule,
        Cor_Collection *magic_rules);

void make_new_rule_vars(Cor_Clause *, int);
Cor_CArg *new_rule_var(Cor_Clause *, int);
Cor_CArg *make_supindex_var(Cor_Clause *adrule, int varnum,
        char letter = 'I');
Cor_CArg& new_pred_name(Cor_CArg& name);
Cor_CArg *new_pred_name(char *name);
Cor_CArg *new_interface_pred_name(char *name);

Cor_Literal *build_magic_pred(Cor_Clause *adrule, Cor_Literal *pred,
	int use_share_opt, int argnum = 0);
Cor_Literal *build_interface_magic_pred(Cor_Clause *adrule, Cor_Literal *pred,
	int use_share_opt, int argnum);

int count_bound_functor_args(Cor_Literal *head);
Cor_Literal *make_functor_literal(Cor_Clause *newrule, Cor_Literal *head,
        int argnum, int newvarnum);
void create_functor_literals(Cor_Clause *);
Cor_Literal *build_head_pred(Cor_Clause *newrule, Cor_Literal *oldhead);
void create_interface_index(Cor_Literal *pred);

Cor_Literal *make_vararglist_literal(Cor_Clause *rule,
        Cor_CArg& name, int startvarnum, int arity);
Cor_Literal *make_vararglist_literal(Cor_Clause *rule, char *name,
	int startvarnum, int arity);

// *************************************************************************

#endif _SupMagic_H_
